﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Web.Services.Protocols;
using System.Xml;
using System.Net;
using System.IO;

namespace SSRSExtractor
{
    public partial class frmMain : Form
    {
        public frmMain()
        {
            InitializeComponent();

            GetLocations();

            cmbLocations.SelectedIndex = 0;
        }

        private void GetLocations()
        {
            ssrsWebService.ReportingService2010 rs = new ssrsWebService.ReportingService2010();
            rs.Credentials = System.Net.CredentialCache.DefaultCredentials;
            try
            {
                ssrsWebService.CatalogItem[] items = rs.ListChildren(@"/", false);
                foreach (ssrsWebService.CatalogItem item in items)
                {
                    cmbLocations.Items.Add(item.Name);
                }
            }
            catch (SoapException ex)
            {
                lbStatus.Text = ex.Message;
            }
        }

        private void btnGo_Click(object sender, EventArgs e)
        {
            lbStatus.Text = "Processing...";
            lbStatus.Visible = true;

            Application.DoEvents();

            string sFrom = cmbLocations.Text;
            string sOutputDir;
            string sOutFile = "";

            ssrsWebService.ReportingService2010 rs = new ssrsWebService.ReportingService2010();
            rs.Credentials = System.Net.CredentialCache.DefaultCredentials;
            try
            {
                ssrsWebService.CatalogItem[] items = rs.ListChildren(string.Format(@"/{0}", sFrom), true);

                progBar.Maximum = items.Count();
                progBar.Width = items.Count();
                progBar.Value = 0;

                foreach (ssrsWebService.CatalogItem item in items)
                {
                    if (item.TypeName == "Report")
                    {
                        byte[] rpt_def = null;
                        XmlDocument doc = new XmlDocument();

                        rpt_def = rs.GetItemDefinition(item.Path);
                        MemoryStream stream = new MemoryStream(rpt_def);

                        sOutputDir = string.Format(@"{0}{1}", txtOutput.Text, item.Path.Replace(item.Name, String.Empty).Replace("/", "\\"));
                        sOutFile = string.Format(@"{0}{1}.rdl", sOutputDir, item.Name);

                        if (File.Exists(sOutFile)) File.Delete(sOutFile);
                        if (!Directory.Exists(sOutputDir)) Directory.CreateDirectory(sOutputDir);

                        doc.Load(stream);
                        doc.Save(sOutFile);

                        progBar.Value += 1;
                    }
                }

                lbStatus.Text = "Complete";
            }
            catch (SoapException ex)
            {
                lbStatus.Text = ex.Message;
            }
        }

        private void txtOutput_TextChanged(object sender, EventArgs e)
        {

        }
    }
}


